

/* $Author: claudio $
 *
 * $Revision: 1.1.1.1 $
 *
 * $Log: spltest.cpp,v $
 * Revision 1.1.1.1  2012-09-05 08:17:22  claudio
 * Interpolator utility classes
 *
 */

#include <cstdlib>
#include <iostream>
#include <iomanip>
#include "spline.h"


using namespace std;
using namespace Interpolator;

int main(){
	
	try{
		double i_qd[]={0.0,14.8056,74.028,148.056,222.084,296.112,333.126,370.14};
		double g_qd[]={0.0,0.7745,3.9519,7.9231,11.8187,15.7069,17.5649,19.2667};
// 		doubleVector iqd;
// 		doubleVector fieldqd;
		vector<double> iqd;
		vector<double> fieldqd;

		//controle printout of table
		int PRECISION=16;
		int WIDTH=20;
		
		for (unsigned int i=0;i<8;i++){
			iqd.push_back(i_qd[i]);
			fieldqd.push_back(g_qd[i]);
			
			cout << setprecision(PRECISION) << setw(WIDTH) << right;
			cout << iqd[i];
			
			cout << setprecision(PRECISION) << setw(WIDTH) << right;
			cout << fieldqd[i] << endl;
		}
		Spline* dir= new Spline(iqd,fieldqd);
		Spline* inv= new Spline(fieldqd,iqd);
		
		
		double min=0.0,max=i_qd[7];
		unsigned int steps=200;
		double mincur=min;
		double inccur=(max-min)/steps;
		double I,g,inv_I;
		cout << setw(WIDTH) << right;
		cout << "I";
		
		cout << setw(WIDTH) << right;
		cout << "g" ;
		
		cout << setw(WIDTH) << right;
		cout << "inv_I" ;
		
		

		cout << endl;
		for(unsigned int i=0;i<=steps;i++){
			I=mincur+ i*inccur;
			g=dir->evaluate(I);
			inv_I=inv->evaluate(g);
			
			
			
			cout << setprecision(PRECISION) << setw(WIDTH) << right;
			cout << I;
			
			cout << setprecision(PRECISION) << setw(WIDTH) << right;
			cout  << g;
			
			cout << setprecision(PRECISION) << setw(WIDTH) << right;
			cout << inv_I;
			
			
			if(I != 0.0) {
				cout << setprecision(PRECISION) << setw(WIDTH) << right;
				cout  << 10000.0*((I-inv_I)/I);
			}
			else{
				cout << setprecision(PRECISION) << setw(WIDTH) << right;
				cout  << 0.0;
			}
			
// 			if(dir->bracket(g,I,1.0e-4,xmin,xmax)){
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << xmin;
// 				
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << xmax;
// 				
// 				double I2=dir->solve(g,xmin,xmax,1.0e-8,100);
// 				
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << I2;
// 				
// 			}
// 			else{
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << "------";
// 				
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << "++++++";
// 				
// 				cout << setprecision(PRECISION) << setw(WIDTH) << right;
// 				cout << "//////";
// 			}
			{

				
				double I2=dir->inverse_evaluate(g,I);
				
				cout << setprecision(PRECISION) << setw(WIDTH) << right;
				cout << I2;
				
			}

			
			cout << endl;
		}
		
		delete inv;
		delete dir;
	}
	catch(std::invalid_argument& ex)
	{
		cout<<ex.what()<<endl;
	}
	return 0;
}
