/*
 * program to test spline classes
 *
 * $Author: claudio $
 *
 * $Revision: 1.1 $
 *
 * $Log: test_inverse.cpp,v $
 * Revision 1.1  2017-03-03 15:32:40  claudio
 * correctetd   spline::inverse_calculate if returned value is at range limit
 *
 * Revision 1.1.1.1  2012-09-05 08:17:22  claudio
 * Interpolator utility classes
 *
 *
 */

#include <iostream>
#include "spline.h"
#include <cmath>
//#include <stdexcept>

using namespace std;
using namespace Interpolator;
int main(){
	 cout << "test spline::inverse_evaluate" << endl;
	{
		
		doubleVector x,y;
		x.push_back(10.0); y.push_back(83.6);
		x.push_back(12);   y.push_back(68.3);
		x.push_back( 14);  y.push_back( 55.7);
		x.push_back(      16); y.push_back(45.5);
		x.push_back(       18); y.push_back(37.3);
		x.push_back(       20); y.push_back(30.7);
		x.push_back(       22); y.push_back(     25.4);
		x.push_back(       24); y.push_back(     21.2);
		x.push_back(       26); y.push_back(     17.9);
		x.push_back(       28); y.push_back(     15.2);
		x.push_back(      30); y.push_back(     13.1);
		x.push_back(      32); y.push_back(     11.4);
		x.push_back(      34); y.push_back(     10.1);
		x.push_back(      36); y.push_back(     9);
		x.push_back(      40); y.push_back(     7.5);
		x.push_back(      50); y.push_back(     5.77);
		Spline *lambdasplie = new Spline(x,y);
		double gmin,gmax;
		
		lambdasplie->get_range(gmin,gmax);
		double max = lambdasplie->evaluate(gmin);
		double min = lambdasplie->evaluate(gmax);
		double initial=min +((max-min)/2);
		
		double l=min;
		double gap, linv;
		cout << "l\tgap\tlinverse" <<  endl;
		cout.precision(8);
		while (l<max){
			gap = lambdasplie->inverse_evaluate(l,initial);
			linv =  lambdasplie->evaluate(gap);
			cout << l <<"\t" << gap << "\t" << linv <<endl;
			l+=0.05;
		}
		delete lambdasplie;
	}
	return 0;
}
