/*
 * program to test multipolynomial class
 *
 * $Author: claudio $
 *
 * $Revision: 1.1.1.1 $
 *
 * $Log: test_multipoly.cpp,v $
 * Revision 1.1.1.1  2012-09-05 08:17:22  claudio
 * Interpolator utility classes
 *
 */

#include <iostream>
#include "multipolynomial.h"

using namespace std;
using namespace Interpolator;

int main(){
	cout << "test of multiPolynomial interpolator class" << endl;
	try{
	//create interpolating polynomials
		
		InterpolatingPolynomial p0,p1,p2;
		p0.xMin=0.5;
		p0.xMax=1.5;
		p0.coefficient.push_back(1.1);
		
		p1.xMin=1.5;
		p1.xMax=2.5;
		p1.coefficient.push_back(1.1);
		p1.coefficient.push_back(2.2);
		
		p2.xMin=2.5;
		p2.xMax=3.5;
		p2.coefficient.push_back(1.1);
		p2.coefficient.push_back(2.2);
		p2.coefficient.push_back(3.3);
		
	//stuff polynomial into vector
		
		InterpolatingPolynoamialVector pvector;
		pvector.push_back(p0);
		pvector.push_back(p1);
		pvector.push_back(p2);
		
		multiPolynomial *multipoly = new multiPolynomial(pvector);
		double minX,maxX;
		multipoly->get_range(minX,maxX);
		if( (minX != p0.xMin) || ( maxX != p2.xMax) ){
			cout << "multiPoly.get_range(): error " << minX << " " << maxX << " " << p0.xMin << " " << p2.xMax << endl;
			return -1; //stop further testing
		}
		delete multipoly;
	}
	catch(...){
		cerr << " unexpected excpetion!" << endl;
		return -1;
	}
	
	{
		cout << "test a single 2nd degree polynomial " << endl;
		try{
			InterpolatingPolynomial p0;
			p0.xMin=0.0;
			p0.xMax=4.0;
			p0.coefficient.push_back(0.0); //a0
			p0.coefficient.push_back(0.0); //a1
			p0.coefficient.push_back(1.0); //a2 --> Y=X*X 
			InterpolatingPolynoamialVector pvector;
			pvector.push_back(p0);
			multiPolynomial *multipoly = new multiPolynomial(pvector);
			double v=0.0,y;
			y=multipoly->evaluate(v); if( y != 0.0 ){ cerr << "value not correct (0.0): " << y << endl; return -1; }
			v=1.0;
			y=multipoly->evaluate(v); if( y != 1.0 ){ cerr << "value not correct (1.0): " << y << endl; return -1; }
			v=4.0;
			y=multipoly->evaluate(v); if( y != 16.0 ){ cerr << "value not correct (16.0): " << y << endl; return -1; }
			doubleVector X;
			for (int i=0; i<=400;i++) X.push_back(i/100.0); //create range for testing
			doubleVector Y=multipoly->evaluate(X);
			cout << "----------------------------------" << endl;
			for (unsigned int i=0; i < X.size(); i++) cout << X[i] << "\t" << Y[i] << endl;
			cout << "----------------------------------" << endl;
			delete multipoly;
		}
		catch(std::range_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		catch(std::length_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		try{
	//create interpolating polynomials
			cout << "test non contiguos" << endl;
			InterpolatingPolynomial p0,p1,p2;
			p0.xMin=0.5;
			p0.xMax=1.5;
			p0.coefficient.push_back(1.1);
			
			p1.xMin=1.6; // <-------
			p1.xMax=2.5;
			p1.coefficient.push_back(1.1);
			p1.coefficient.push_back(2.2);
			
			p2.xMin=2.5;
			p2.xMax=3.5;
			p2.coefficient.push_back(1.1);
			p2.coefficient.push_back(2.2);
			p2.coefficient.push_back(3.3);
			
	//stuff polynomial into vector
			
			InterpolatingPolynoamialVector pvector;
			pvector.push_back(p0);
			pvector.push_back(p1);
			pvector.push_back(p2);
			
			multiPolynomial *multipoly = new multiPolynomial(pvector);
			delete multipoly;
		}
		catch(std::domain_error& ex){
			cout << "OK expected  exception: " << ex.what() << endl;
			
		}
		catch(...){
			cerr << " unexpected excpetion!" << endl;
			return -1;
		}
		
		try{
	//create interpolating polynomials
			cout << "test 3 polynomials" << endl;
			InterpolatingPolynomial p0,p1,p2;
			p0.xMin=0.0;
			p0.xMax=1.5;
			p0.coefficient.push_back(1.0); //c[0]
			
			p1.xMin=1.5;
			p1.xMax=2.5;
			p1.coefficient.push_back(0.0); //c[0]
			p1.coefficient.push_back(0.0); //c[1]
			p1.coefficient.push_back(1.0); //c[2]
			
			p2.xMin=2.5;
			p2.xMax=3.5;
			p2.coefficient.push_back(5.0);  //c[0]
			p2.coefficient.push_back(-2.0); //c[1]
	//stuff polynomial into vector
			
			InterpolatingPolynoamialVector pvector;
			pvector.push_back(p0);
			pvector.push_back(p1);
			pvector.push_back(p2);
			
			multiPolynomial *multipoly = new multiPolynomial(pvector);
			doubleVector X;
			for (int i=0; i<=350;i++) X.push_back(i/100.0); //create range for testing
			doubleVector Y=multipoly->evaluate(X);
			cout << "-+++++++++++++++++++++++++++++++++" << endl;
			for (unsigned int i=0; i < X.size(); i++) cout << X[i] << "\t" << Y[i] << endl;
			cout << "++++++++++++++++++++++++++++++++++" << endl;
			delete multipoly;
		}
		catch(std::domain_error& ex){
			cout << "unexpected  exception: " << ex.what() << endl;
			return -1;
		}
		catch(std::range_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		catch(std::length_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		catch(...){
			cerr << " unexpected excpetion!" << endl;
			return -1;
		}
		
		try{
	//create interpolating polynomials
			cout << "test 3 identical polynomials" << endl;
			InterpolatingPolynomial p0,p1,p2;
			p0.xMin=0.0;
			p0.xMax=1.5;
			p0.coefficient.push_back(1.0); //c[0]
			
			
			InterpolatingPolynoamialVector pvector;
			pvector.push_back(p0);
			pvector.push_back(p0);
			pvector.push_back(p0);
			
			multiPolynomial *multipoly = new multiPolynomial(pvector);
			doubleVector X;
			for (int i=0; i<=150;i++) X.push_back(i/100.0); //create range for testing
			doubleVector Y=multipoly->evaluate(X);
			cout << "**********************************" << endl;
			for (unsigned int i=0; i < X.size(); i++) cout << X[i] << "\t" << Y[i] << endl;
			cout << "**********************************" << endl;
			delete multipoly;
		}
		catch(std::domain_error& ex){
			cout << "OK, exception caught: " << ex.what() << endl;
		}
		catch(std::range_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		catch(std::length_error& ex){
			std::cerr << ex.what() << std::endl;
			return -1;
		}
		catch(...){
			cerr << " unexpected excpetion!" << endl;
			return -1;
		}
		try{
	//create interpolating polynomials
			cout << "test copy constructor" << endl;
			InterpolatingPolynomial p0,p1,p2;
			p0.xMin=0.0;
			p0.xMax=1.5;
			p0.coefficient.push_back(1.0); //c[0]
			
			p1.xMin=1.5;
			p1.xMax=2.5;
			p1.coefficient.push_back(0.0); //c[0]
			p1.coefficient.push_back(0.0); //c[1]
			p1.coefficient.push_back(1.0); //c[2]
			
			p2.xMin=2.5;
			p2.xMax=3.5;
			p2.coefficient.push_back(5.0);  //c[0]
			p2.coefficient.push_back(-2.0); //c[1]
	//stuff polynomial into vector
			
			InterpolatingPolynoamialVector pvector;
			pvector.push_back(p0);
			pvector.push_back(p1);
			pvector.push_back(p2);
			
			multiPolynomial *multipoly = new multiPolynomial(pvector);
			multiPolynomial copypoly=*multipoly;
			doubleVector X;
			for (int i=0; i<=350;i++) X.push_back(i/100.0); //create range for testing
			doubleVector Y=multipoly->evaluate(X);
			doubleVector Yc=copypoly.evaluate(X);
			
			for (unsigned int i=0; i < X.size(); i++){
				if (Y[i] != Yc[i])
					cerr << "COPY ERROR: " << X[i] << " " << Y[i] << " " << Yc[i] <<endl;
			}
			delete multipoly;
		}
		catch(...){
			cerr << " test copy constructor: unexpected excpetion!" << endl;
			return -1;
		}
	}
	{
		cout << "test interpolatore for constat value on simmetric range" << endl;
		InterpolatingPolynomial p0;
		InterpolatingPolynoamialVector pvector;
		p0.xMin=-5.0;
		p0.xMax=5.0;
		p0.coefficient.push_back(0.52); //c[0]
		pvector.push_back(p0);
		multiPolynomial *multipoly = new multiPolynomial(pvector);
		double a0=-4.99;
		cout << "for "<< a0 << " "<< multipoly->evaluate(a0);
		a0=4.99;
		cout << "for "<< a0 << " "<< multipoly->evaluate(a0);
		delete multipoly;
	}
	return 0;
}
